/*
** SellaNMS
** $Id: VERSION,v 2.25 2006/01/22 22:16:37 sella Exp $
** Copyright (c) 2001-2006 Digital Genesis Software. All Rights Reserved.
** Released under the GPL Version 2 License.
** http://www.digitalgenesis.com
*/

This version covers the features slated to be implemented within current and
future versions of SellaNMS.

SellaNMS v0.1.0
----------------

X  Setup MySQL Backend [Bill]
X    Create sella_nms database [Bill]
X      Create icmp table [Bill]
X  Setup CVS and check everything into it. [Jim]
X  Setup directory structure [Jim]
X    Create place holder Makefile [Jim]
X    Create place holder README, etc. [Jim]
X     Create example config file [Jim]
X     Create parent program (discover daemon) [Bill]
X     Create base module [Bill]
X       Create base config module [Jim]
X         Create a config container [Jim]
X         Create flatfile config module [Jim]
X       Create base storage module [Bill]
X         Create mysql storage module [Jim]
X       Create base discovery module [Bill]
X         Create icmp dicovery module [Bill]
X  Create PHP page to display discovered objects [Bill]
X  Setup usable Makefiles for project [Jim]

SellaNMS v0.2.0
----------------

X  SNMP discovery module. [Jim]
X  Rewrite ICMP module more efficently. [Bill]
X  Topology discovery module. [Bill]
X  Enhance PHP page to display discovered devices. [Bill]
X  Rediscovery [Jim/Bill]

SellaNMS v0.3.0
----------------

X  Monitoring Daemon [Jim]
X    ICMP Monitoring Module [Jim]
X    ICMP Correlation Module [Bill]
X    SNMPTrap Monitoring Module [Jim]
X    SNMPTrap Correlation Module [Bill]
X    Alert Monitoring Module [Jim/Bill]
X  Add syslog support to modules. [Jim]
X  Create PHP page to display Alerts/Traps. [Bill/Jim]

SellaNMS v1.0.0
----------------

X  Minor Enhancements [Jim]
X	Bug fixes [Jim/Bill]
X  Fixup Policy/Format/Maps

SellaNMS v2.0.0
----------------

X  Controller daemon
X    Basic watchdog watchdog (process alive?)
X  Daemonize modules/remove scheduler
X  State daemon

SellaNMS v2.1.0
----------------

  PHP GUI retired in favor of Java GUI
  Restructure daemon code from C++ into standard C.
  Controller daemon
    Advanced watchdog (memory limits, responding)
    Control socket for reload, stats, etc.

SellaNMS v2.2.0
----------------

  SNMP Module

SellaNMS v2.3.0
----------------

  SNMP Graphing Capability

SellaNMS v2.4.0
----------------

  Non-SNMP Host Support
  Monitor Host Services
    TCP Port Availability Test
    UDP Port Availability Test

SellaNMS v2.5.0
----------------

  Advanced Host Service Monitoring
    HTTP
    DNS
    SMTP
    Telnet
    SSH
    LDAP
    NetBios

SellaNMS v3.0.0
----------------

  Advanced clustering features


Future Features
---------------
Discovery
 -Layer 2 Discovery
  +ILMI
  +PNNI
  +Ethernet (ARP)
 -Generic popen discovery module
  +Could run nmap to detect OS, etc.
Monitoring
 -ICMP Polling (Closest first by dependancy tree)
  +Network Element
  +Edge Interfaces
  +Packet Loss
  +High Latency
 -SNMP Polling (Closest first by dependancy tree)
  +Interface State Change
  +Tempature
  +CPU Load
  +Processes (Server)
  +BGP Failure detect
  +ARP Entry changes
  +LSP BW vs LSP Reservation
 -Bandwidth Traps
  +Generate Traps for external source for over util on link.
  +Generate Alerts for over util on link, CPU, temp, etc.
  +Queue Drops
  +CoS Queue
  +LSP BW over X util
  +LSP reservation over X util
 -Alerts
  +Emails Alerts
  +Alerts include HTML link to get to the problem.
  +Opens, Updates and even closes tickets.
  +Send events/traps to external database.
  +Send events/traps to flatfile.
 -Services
  +Send email thru system, and recieve the from from IMAP/POP. Graph the delivery time.
  +Request web page, and verify its not 404, etc, and size is within spec.
  +Verify AXFR and DNS requests.
 -Host
  +Flexable host daemon to interact with NMS.
Performance
 -Netflow v5 Support
  +iBGP neighbor for Intermediate ASN Support
  +tcp/udp port utilization
  +Top ASN Report
 -Bandwidth
  +Utilize RRDTool library.
  +Abberant Behavoir Detection (RRDTool)
  +Hot List - Interfaces nearest to saturation.
  +Prediction of over utilization.
 -Percentile (80, 90, 95th)
 -CPU/Temp
  +Router
  +Server
 -Memory Usage
 -Storage Usage
  +Server
Capacity Management (Accounting)
 -Hardware w/Serials
 -Port Utilization
 -Slot Utilization
 -Predict need for new ports based on utilization over time.
IP Management
 -IP Utilization Levels (Audit)
 -IP Allocation (Regionalized)
 -Predict need for additional addresses.
Configuration
 -Configure daemon config file.
 -Configure Web GUI
 -XML Based Config Module
 -MySQL Based Config Module
Ticket System/Work Flow
 -Trouble Tickets
  +Monitoring opens ticks automatically (update and close too)
Interface (GUI)
 -PHP Web Interface
  +Map view of network
  +View Problems (Alerts/Traps)
  +Web based tools like traceroute, ping, whois, page tech, etc.
 -KDE GUI App (System Tray, ala PingThing2)
  +Systray Icon displays overall network status. Open for detail.
 -Windows GUI (System Tray)
  +Port of KDE GUI App.
Security
 -Radius Config
 -Tacacs+ Config
Troubleshooter/Analizer
 -Analize Data and locate cause of problem.
 -Does easy troubleshooting and data collection.
 -Suggestions
  +What it probably is. (Circuit Loop, etc)
  +What its like, but its not because of X.
 -Robot
  +Tries easy stuff like bouncing an interface when PPP goes down.
Change Control
 -Configuration collector (ie: RANCID)
Misc
 -Table for GUI to interact with Daemon.
